Subject: 27.0.50; package.el install does not respect dependencies

From: Oleh Krehel <[email-masked]>
Date: Wed, 16 Oct 2019 10:44:02 +0200

On MELPA, the package `swiper' depends on the package `ivy'.  The user
has both packages installed.  Both packages get an update, where
`swiper' now depends on a new feature of `ivy'. When the user does
`package-menu-mark-upgrades' and `package-menu-execute', `swiper' gets
compiled /first/ with an /outdated/ (the one that was installed) version
of `ivy', and errors and warnings ensue.

I think this is not a MELPA issue, the same would happen for GNU ELPA.
This should be fixed in package.el.

Two things to fix here:

1. Packages should be compiled in order of dependence.
2. The package that depends on the other should be compiled with a new
version of the other one.